The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::BeeThree Class Reference

STK Hammond-oid organ FM synthesis instrument. More...

`#include <BeeThree.h>`

Inheritance diagram for stk::BeeThree:

List of all members.

## Public Member Functions
| BeeThree (void)
| Class constructor.
| ~BeeThree (void)
| Class destructor.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK Hammond-oid organ FM synthesis instrument.

This class implements a simple 4 operator topology, also referred to as algorithm 8 of the TX81Z.

        Algorithm 8 is :
                         1 --.
                         2 -\|
                             +-> Out
                         3 -/|
                         4 --

Control Change Numbers:

- Operator 4 (feedback) Gain = 2
- Operator 3 Gain = 4
- LFO Speed = 11
- LFO Depth = 1
- ADSR 2 & 4 Target = 128

The basic Chowning/Stanford FM patent expired in 1995, but there exist follow-on patents, mostly assigned to Yamaha. If you are of the type who should worry about this (making money) worry away.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::BeeThree::BeeThree | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::BeeThree::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::FM.

    00099 {
    00100   unsigned int nChannels = lastFrame_.channels();
    00101 #if defined(_STK_DEBUG_)
    00102   if ( channel > frames.channels() - nChannels ) {
    00103     oStream_ << "BeeThree::tick(): channel and StkFrames arguments are incompatible!";
    00104     handleError( StkError::FUNCTION_ARGUMENT );
    00105   }
    00106 #endif
    00107
    00108   StkFloat *samples = &frames[channel];
    00109   unsigned int j, hop = frames.channels() - nChannels;
    00110   if ( nChannels == 1 ) {
    00111     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00112       *samples++ = tick();
    00113   }
    00114   else {
    00115     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00116       *samples++ = tick();
    00117       for ( j=1; j<nChannels; j++ )
    00118         *samples++ = lastFrame_[j];
    00119     }
    00120   }
    00121
    00122   return frames;
    00123 }

The documentation for this class was generated from the following file:

- BeeThree.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.